Hero Image
Leetcode 541 - 反转字符串II

题目链接 题目描述 给定一个字符串 s 和一个整数 k,从字符串开头算起, 每计数至 2k 个字符,就反转这 2k 个字符中的前 k 个字符。 如果剩余字符少于 k 个,则将剩余字符全部反转。 如果剩余字符小于 2k 但大于或等于 k 个,则反转前 k 个字符,其余字符保持原样。 示例: 输入: s = “abcdefg”, k = 2 输出: “bacdfeg” 思路 我使用的是最简单的思路,即将这条题目理解为局部的反转字符串 所以一部分代码就是反转字符串,然后外层再嵌套一个选取局部区间的循环即可 初始化 反转字符串部分为双指针操作,即相向双指针,左指针为起点,右指针为终点 外层嵌套直接一个for循环或者while循环,根据剩余字符的数量分类讨论 循环条件 对反转字符串reverse,两个指针相遇后循环停止 外层循环即遍历完整个字符串数组即可,不过步长不为1,而是2*k 代码 Python 1. 简单粗暴 class Solution(object): def reverseStr(self, s, k): """ :type s: str :type k: int :rtype: str """ l = len(s) s = list(s) left = 0 while(left<l): if(left+k>l-1): self.reverse(s,left,l - 1) else: self.reverse(s,left,left+k - 1) left+=2*k s = "".join(s) return s def reverse(self,s,left, right): while(left<right): x = s[left] s[left] = s[right] s[right] = x left += 1 right -= 1 return s 复杂度分析 时间复杂度: O(n) (尽管是嵌套循环,但是对于外循环中的每个元素,它的reverse是针对有限个元素left to right的,而不是每个元素都要再循环n次,所以依旧是常数次)

    Hero Image
    Leetcode 27 - 移除元素

    题目链接 题目描述 给你一个数组 nums 和一个值 val,你需要 原地 移除所有数值等于 val 的元素,并返回移除后数组的新长度 不要使用额外的数组空间,你必须仅使用 O(1) 额外空间并原地修改输入数组 元素的顺序可以改变。你不需要考虑数组中超出新长度后面的元素 示例 1: 给定 nums = [3,2,2,3], val = 3, 函数应该返回新的长度 2, 并且 nums 中的前两个元素均为 2。 你不需要考虑数组中超出新长度后面的元素 示例 2: 给定 nums = [0,1,2,2,3,0,4,2], val = 2, 函数应该返回新的长度 5, 并且 nums 中的前五个元素为 0, 1, 3, 0, 4 你不需要考虑数组中超出新长度后面的元素 思路 快慢指针:一个快指针,一个慢指针,在一个for循环下完成,比暴力更高效 快慢指针是同向指针的一种,只是快慢指针的步长一般都是固定的 慢指针用于存放非val的元素,快指针用于跳过为val的元素 快指针遍历完即代表结束,直接递增即可 慢指针的增长只依赖于判断当前元素,题目不要求考虑不符合要求的元素部分,所以慢指针需要遇到符合条件的元素(这个需要快指针来帮忙判断)才能+1 初始化 快慢指针为同向指针,都初始化为0 循环条件 只需要观察快指针,当快指针遍历整个数组即意味着结束 当快指针等于数组长度-1的时候是可以进入循环的,因为如果最后一个元素不等于 val,那么是需要将该元素输入到nums[left]的,即慢指针仍然是有可能要利用到快指针的值的(此时快指针指向数组最后一个元素) 代码 Python class Solution(object): def removeElement(self, nums, val): """ :type nums: List[int] :type val: int :rtype: int """ left = 0 right = 0 k = 0 while right <= len(nums)-1: if nums[right] != val: nums[left] = nums[right] k+=1 left+=1 right+=1 return k 复杂度分析 时间复杂度: O(n) (while单循环,单循环内都是常数时间的操作)